# Class ElementKindVisitor9<R,P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,P>
javax.lang.model.util.SimpleElementVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor7<R,P>
javax.lang.model.util.ElementKindVisitor8<R,P>
javax.lang.model.util.ElementKindVisitor9<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,P>`

Direct Known Subclasses:
  `ElementKindVisitor14`

@SupportedSourceVersion(RELEASE_14) public class ElementKindVisitor9<R,P> extends ElementKindVisitor8<R,P>
A visitor of program elements based on their kind with default behavior appropriate for source versions `RELEASE_9` through `RELEASE_14`. For elements `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  9
See Also:
  - Compatibility note for subclasses
  - `ElementKindVisitor6`
  - `ElementKindVisitor7`
  - `ElementKindVisitor8`

- ## Field Summary

  ### Fields declared in class SimpleElementVisitor6

  `DEFAULT_VALUE`
  Modifier and Type
  Field
  Description
  `protected final R`
  `DEFAULT_VALUE`
  Default value to be returned; `defaultAction` returns this value unless the method is overridden.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ElementKindVisitor9()`
  Constructor for concrete subclasses; uses `null` for the default value.
  `protected`
  `ElementKindVisitor9(R defaultValue)`
  Constructor for concrete subclasses; uses the argument for the default value.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `R`
  `visitModule(ModuleElement e, P p)`
  Visits a module element.

  ### Methods declared in class ElementKindVisitor7

  `visitVariableAsResourceVariable`
  Modifier and Type
  Method
  Description
  `R`
  `visitVariableAsResourceVariable(VariableElement e, P p)`
  Visits a `RESOURCE_VARIABLE` variable element.

  ### Methods declared in class ElementKindVisitor6

  `visitExecutable, visitExecutableAsConstructor, visitExecutableAsInstanceInit, visitExecutableAsMethod, visitExecutableAsStaticInit, visitPackage, visitType, visitTypeAsAnnotationType, visitTypeAsClass, visitTypeAsEnum, visitTypeAsInterface, visitTypeAsRecord, visitTypeParameter, visitVariable, visitVariableAsBindingVariable, visitVariableAsEnumConstant, visitVariableAsExceptionParameter, visitVariableAsField, visitVariableAsLocalVariable, visitVariableAsParameter`
  Modifier and Type
  Method
  Description
  `R`
  `visitExecutable(ExecutableElement e, P p)`
  Visits an executable element.
  `R`
  `visitExecutableAsConstructor(ExecutableElement e, P p)`
  Visits a `CONSTRUCTOR` executable element.
  `R`
  `visitExecutableAsInstanceInit(ExecutableElement e, P p)`
  Visits an `INSTANCE_INIT` executable element.
  `R`
  `visitExecutableAsMethod(ExecutableElement e, P p)`
  Visits a `METHOD` executable element.
  `R`
  `visitExecutableAsStaticInit(ExecutableElement e, P p)`
  Visits a `STATIC_INIT` executable element.
  `R`
  `visitPackage(PackageElement e, P p)`
  Visits a package element.
  `R`
  `visitType(TypeElement e, P p)`
  Visits a type element.
  `R`
  `visitTypeAsAnnotationType(TypeElement e, P p)`
  Visits an `ANNOTATION_TYPE` type element.
  `R`
  `visitTypeAsClass(TypeElement e, P p)`
  Visits a `CLASS` type element.
  `R`
  `visitTypeAsEnum(TypeElement e, P p)`
  Visits an `ENUM` type element.
  `R`
  `visitTypeAsInterface(TypeElement e, P p)`
  Visits an `INTERFACE` type element.
  `R`
  `visitTypeAsRecord(TypeElement e, P p)`
  Visits a `RECORD` type element.
  `R`
  `visitTypeParameter(TypeParameterElement e, P p)`
  Visits a type parameter element.
  `R`
  `visitVariable(VariableElement e, P p)`
  Visits a variable element.
  `R`
  `visitVariableAsBindingVariable(VariableElement e, P p)`
  Visits a `BINDING_VARIABLE` variable element.
  `R`
  `visitVariableAsEnumConstant(VariableElement e, P p)`
  Visits an `ENUM_CONSTANT` variable element.
  `R`
  `visitVariableAsExceptionParameter(VariableElement e, P p)`
  Visits an `EXCEPTION_PARAMETER` variable element.
  `R`
  `visitVariableAsField(VariableElement e, P p)`
  Visits a `FIELD` variable element.
  `R`
  `visitVariableAsLocalVariable(VariableElement e, P p)`
  Visits a `LOCAL_VARIABLE` variable element.
  `R`
  `visitVariableAsParameter(VariableElement e, P p)`
  Visits a `PARAMETER` variable element.

  ### Methods declared in class SimpleElementVisitor6

  `defaultAction`
  Modifier and Type
  Method
  Description
  `protected R`
  `defaultAction(Element e, P p)`
  The default action for visit methods.

  ### Methods declared in class AbstractElementVisitor6

  `visit, visit, visitRecordComponent, visitUnknown`
  Modifier and Type
  Method
  Description
  `final R`
  `visit(Element e)`
  Visits any program element as if by passing itself to that element's `accept` method and passing `null` for the additional parameter.
  `final R`
  `visit(Element e, P p)`
  Visits any program element as if by passing itself to that element's `accept` method.
  `R`
  `visitRecordComponent(RecordComponentElement e, P p)`
  Visits a record component element.
  `R`
  `visitUnknown(Element e, P p)`
  Visits an unknown kind of element.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ElementKindVisitor9

    protected ElementKindVisitor9()
    Constructor for concrete subclasses; uses `null` for the default value.

  - ### ElementKindVisitor9

    protected ElementKindVisitor9(R defaultValue)
    Constructor for concrete subclasses; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`

- ## Method Details

  - ### visitModule

    public R visitModule(ModuleElement e, P p)
    Visits a module element.
    Specified by:
      `visitModule` in interface `ElementVisitor<R,P>`
    Overrides:
      `visitModule` in class `AbstractElementVisitor6<R,P>`
    Implementation Requirements:
      This implementation calls `defaultAction`.
    Parameters:
      `e` - the element to visit
      `p` - a visitor-specified parameter
    Returns:
      the result of `defaultAction`